/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* italic.c åǽ */
/* $Id: italic.c,v 1.4 1998/05/31 15:11:47 elca Exp elca $ */

#include "Xatm.h"

/*#define dprintf(str) fprintf str */
#define dprintf(str) /* */

int XatmOpenScalable_italic(FontPathElementPtr fpe,
			    FontPtr	           *pFont,
			    int                flags,
			    FontEntryPtr       entry,
			    char               *fileName,
			    FontScalablePtr    vals,
			    fsBitmapFormat     format,
			    fsBitmapFormatMask fmask,
			    FontPtr            non_cachable_font) /* We don't do licensing */
{
	int ret;
	int pos;
	char *save_entryfileName;
	char *save_fileName;
	double save_pixel_matrix_2;
	double save_point_matrix_2;
	char entryfileName[MAXFONTFILENAMELEN];
	char fontName[MAXFONTFILENAMELEN];

	/* ͤΥХåå */
	save_entryfileName = entry->u.scalable.fileName;
	save_fileName = fileName;
	save_pixel_matrix_2 = vals->pixel_matrix[2];
	save_point_matrix_2 = vals->point_matrix[2];


	strcpy(entryfileName, entry->u.scalable.fileName);
	pos = strlen(entryfileName) - (XATM_EXT_LEN_I - XATM_EXT_LEN);
	if (pos <= 0) {
		return BadFontName;
	}
	entryfileName[pos] = '\0';
	strcpy(fontName, fileName);
	pos = strlen(fontName) - (XATM_EXT_LEN_I - XATM_EXT_LEN);
	if (pos <= 0) {
		return BadFontName;
	}
	fontName[pos] = '\0';

	/* ͤν񤭴 */
	entry->u.scalable.fileName = entryfileName;
	fileName = fontName;
	vals->pixel_matrix[2] += vals->pixel_matrix[3] * 0.25;
	vals->point_matrix[2] += vals->point_matrix[3] * 0.25;

	dprintf((stdout, "%s %s\n", entry->u.scalable.fileName, fileName));

	ret = XatmOpenScalable(fpe, pFont, flags, entry,
				   fileName, vals, format, fmask,
				   non_cachable_font);

	/* Хååפ */
	entry->u.scalable.fileName = save_entryfileName;
	fileName = save_fileName;
	vals->pixel_matrix[2] = save_pixel_matrix_2;
	vals->point_matrix[2] = save_point_matrix_2;

	return ret;
}

int XatmGetInfoScalable_italic(FontPathElementPtr  fpe,
			       FontInfoPtr	       pFontInfo,
			       FontEntryPtr        entry,
			       FontNamePtr	       pFontName,
			       char	               *fileName,
			       FontScalablePtr     vals)
{
	FontPtr pfont;
	int flags = 0;
	long format = 0;  /* It doesn't matter what format for just info */
	long fmask = 0;
	int ret;

	dprintf((stderr, "\n" __FUNCTION__ "(%x, %x, %x, %x, %s, %x)\n",
		 fpe, pFontInfo, entry, fontName, fileName, vals));

	ret = XatmOpenScalable_italic(fpe, &pfont, flags, entry, fileName, vals,
				      format, fmask, NULL);
	if (ret != Successful)
		return ret;
	*pFontInfo = pfont->info;

	(*pfont->unload_font)(pfont);

	return Successful;
}

/* end */
